function KRISSVectorSMGSwitchOne(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 1;
	end
end

function KRISSVectorSMGSwitchTwo(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 2;
	end
end

function KRISSVectorSMGSwitchThree(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 3;
	end
end

function KRISSVectorSMGSwitchFour(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 4;
	end
end

function KRISSVectorSMGSwitchFive(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 5;
	end
end

function KRISSVectorSMGSwitchSix(actor)
	local gun = ToAHuman(actor).EquippedItem;
	if gun ~= nil then
		gun.Sharpness = 6;
	end
end

function Create(self)

	self.weaponNameTable = {"KRISS Vector SMG (Single-FMJ)","KRISS Vector SMG (Single-HP)","KRISS Vector SMG (Single-AP)","KRISS Vector SMG (Auto-AP)","KRISS Vector SMG (Burst-AP)","KRISS Vector SMG (Single-AP)"};
	self.weaponClassTable = {"HDFirearm","HDFirearm","HDFirearm","HDFirearm","HDFirearm","HDFirearm"};
	self.switchPhase = 0;
	self.switchTimer = Timer();
	self.flipTimer = false;
	self.switchDelay = 2000;

	self.CyclingTimer = Timer()
	self.CyclingMS = 500 --ms
	self.RoundChambered = false
	self.CycleNoiseEmitter = "KRISS Vector SMG Cycle Noise"
	self.Module = "KRISS Vector SMG.rte"

  --You may change following variables to your likings
  self.ParticleMass = 0.25 --Mass of the projectile fired
  self.ParticleVel = 100 --speed of the projectile fired
  self.RecoilMulti = 1 --if for some reason you need to change the recoil without changing mass or velocity use this
  self.Grip = 1 --This is how fast you regain control
  self.MovementPunisherment = 1 --How much you are punished for moving while firing
  self.BipodOffset = Vector(15, 7) --Where the Bipod is on the gun
  self.PinDepth = 10 --How deep the bipod is stuck into the ground
  self.BipodStanceOffset = Vector(0, 9) --Where the actor is relative to the gun when the gun is pinned
  
  --Don't fiddle with these
  self.OriginalName = self.PresetName
  self.Recoil = 0
  self.RecoilRot = 0
  self.ShootTimer = Timer()
  self.SharpRange = self.SharpLength
  self.PinnedPos = self.Pos + self:RotateOffset(self.BipodOffset)
  self.PinnedFlipped = self.HFlipped
  self.PickedUp = false
  self.AgeCheck = 0
  self.Clicked = false
	
end

function Update(self)

	if self.Sharpness ~= 0 then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.parent = ToAHuman(actor);
		end
		if self.flipTimer == false then
			self.flipTimer = true;
			self.switchTimer:Reset();
		end
		if self.switchTimer:IsPastSimMS(self.switchDelay) then
			if self.switchPhase == 0 then
				if MovableMan:IsActor(self.parent) then
					if self.weaponClassTable[self.Sharpness] == "HDFirearm" then
						local switchGun = ToActor(self.parent):AddInventoryItem(CreateHDFirearm(self.weaponNameTable[self.Sharpness]));
					elseif self.weaponClassTable[self.Sharpness] == "TDExplosive" then
						local switchGun = ToActor(self.parent):AddInventoryItem(CreateTDExplosive(self.weaponNameTable[self.Sharpness]));
					elseif self.weaponClassTable[self.Sharpness] == "HeldDevice" then
						local switchGun = ToActor(self.parent):AddInventoryItem(CreateHeldDevice(self.weaponNameTable[self.Sharpness]));
					end
					ToActor(self.parent):GetController():SetState(Controller.WEAPON_DROP,true);
					self.switchPhase = 1;
				else
					self.Sharpness = 0;
				end
			else
				if MovableMan:IsActor(self.parent) then
					if ToActor(self.parent):IsInventoryEmpty() == false then
						ToActor(self.parent):GetController():SetState(Controller.WEAPON_CHANGE_PREV,true);
					end
				end
				self.ToDelete = true;
			end
		else
			if MovableMan:IsActor(self.parent) then
				ToActor(self.parent):GetController():SetState(Controller.WEAPON_FIRE,false);
			end
		end
	end

	--determine the root object.
	if self.RootID ~= 255 then
		self.y = MovableMan:GetMOFromID(self.RootID)
		if self.y then
			if self.y:IsActor() then
				self.z = ToAHuman(MovableMan:GetMOFromID(self.RootID))
				if self.Magazine then
				
					if self:IsReloading() then
						self.justfired = 0
					else
						if self.magcount ~= self.Magazine.RoundCount and self.Magazine.IsFull == false then
							self.justfired = 1
							if self.Magazine.RoundCount == 0 then
								self.RoundChambered = false
							else
								self.RoundChambered = true
							end
						else
							self.justfired = 0
						end
						self.magcount = self.Magazine.RoundCount
						if self.Magazine.IsFull and not self.RoundChambered then
							self.CyclingTimer:Reset()
							self.RoundChambered = true
							self.Magazine.RoundCount = self.Magazine.RoundCount - 1
							self.b = CreateAEmitter(self.CycleNoiseEmitter,self.Module)
							self.b.Pos = self.Pos
							MovableMan:AddParticle(self.b)
						end
						if self.CyclingTimer.ElapsedSimTimeMS < self.CyclingMS then
							self:Deactivate()
						end
					end
				else
					self.justfired = 0
				end
			end
		end
	end
  if self.AgeCheck + 100 < self.Age then
    self.PresetName = self.OriginalName
  end
  self.AgeCheck = self.Age
  local negatore = 1
	if self.HFlipped then
		negatore = -1;
	end
  if self.RotAngle < 0 then
     self.RotAngle = self.RotAngle + math.pi * 2
  else
    if self.RotAngle > math.pi * 2 then
       self.RotAngle = self.RotAngle - math.pi * 2
    end
  end
	local Pinstrength = 0
	--If Pinned check current strength of the terrain the gun is pinned on
	if self.PresetName == self.OriginalName .. " (Braced)" then
    local strikePoint = Vector(0,0);
    local lastPoint = Vector(0,0);
    Pinstrength = SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(-1, self.PinDepth), 0, 0) + SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(0, self.PinDepth), 0, 0) + SceneMan:CastStrengthSumRay(self.PinnedPos, self.PinnedPos + Vector(1, self.PinDepth), 0, 0);
    if Pinstrength < 10*self.PinDepth+self.Recoil*10*self.PinDepth  then
      self.PresetName = self.OriginalName
    end
	end
	
	self.Recoil = self.Recoil * 0.99
	self.RecoilRot = self.RecoilRot * 0.95
	local RecoilReduction = 0.1
	local user = nil
	for parent in MovableMan.Actors do
		if parent.ID == self.RootID then
			user = ToAHuman(parent)
			break
		end
	end
	if user ~= nil then
    local aim = ToAHuman(user):GetAimAngle(false)
    ToAHuman(user):SetAimAngle(aim + self.Recoil*0.0015)
    --Taking the user into account
    local ArmCount = 0
    local ArmLength = 0
    if user.FGArm ~= nil then
      RecoilReduction = RecoilReduction + user.FGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = user.FGArm.Diameter
    end
    if user.BGArm ~= nil then
      RecoilReduction = RecoilReduction + user.BGArm.Mass
      ArmCount = ArmCount + 1
      ArmLength = math.max(user.BGArm.Diameter , ArmLength)
    end
    ArmLength = ArmLength + user.Diameter
    local strikePoint = Vector(0,0);
    local lastPoint = Vector(0,0);
    local dist = SceneMan:CastObstacleRay(self.Pos + self:RotateOffset(self.BipodOffset), Vector(0, user.Height * 0.5) , strikePoint, lastPoint, user.ID, self.IgnoresWhichTeam, -1, 0);
    if dist < 0 then
      dist = user.Height * 0.5
    end
    
    --Regaining control
    local MovementMulti = ((ArmLength/self.MovementPunisherment - math.min(user.Vel.Magnitude , ArmLength/self.MovementPunisherment))/ArmLength*self.MovementPunisherment)
    MovementMulti = MovementMulti / (user.Vel.Magnitude+1)^(self.MovementPunisherment/(user.Diameter+1))
    if self.RecoilRot > 0.01 * MovementMulti^2 * (100+user.Health)/200 then
      self.RecoilRot = self.RecoilRot - 0.01 * MovementMulti^2 * (100+user.Health)/200
    else
      if self.RecoilRot < -0.01 * MovementMulti^2 * (100+user.Health)/200 then
        self.RecoilRot = self.RecoilRot + 0.01 * MovementMulti^2 * (100+user.Health)/200
      else
        self.RecoilRot =  0
      end
    end
    if self.Recoil > self.Grip/10000 * MovementMulti^2 * user.Mass * (100+user.Health)/60000*(300+Pinstrength) then
      self.Recoil = self.Recoil - self.Grip/10000 * MovementMulti^2 * user.Mass * (100+user.Health)/60000*(300+Pinstrength)
    else
      self.Recoil =  0
    end
    
    RecoilReduction = ((RecoilReduction * user.Mass)^0.5 * ((user.Height * 0.5 - dist + 500)*0.002) + Pinstrength*0.02) * (0.2 + MovementMulti*0.8)
    if self.Diameter > user.Diameter then --if the user is shorter than the gun, make it extra important to have an extra arm for support
      RecoilReduction = RecoilReduction * ArmCount * 0.5
    end
    --[[
    if (self.Recoil > 2.5 or self.Recoil < -2.5) or (self.RecoilRot > 1 or self.RecoilRot < -1) then
      if not self.HFlipped then
        user:GetController():SetState(Controller.MOVE_LEFT, true)
        user:GetController():SetState(Controller.MOVE_RIGHT, false)
      else
        user:GetController():SetState(Controller.MOVE_LEFT, false)
        user:GetController():SetState(Controller.MOVE_RIGHT, true)
      end
    end
    ]]--
    if (self.Recoil > 3.5 or self.Recoil < -3.5) or (self.RecoilRot > 2 or self.RecoilRot < -2) then
      user:GetController():SetState(Controller.BODY_CROUCH,true)
    end
    if (self.Recoil > 4.5 or self.Recoil < -4.5) or (self.RecoilRot > 3 or self.RecoilRot < -3) then
      user:GetController():SetState(Controller.WEAPON_DROP,true)
    end
    if self.PickedUp == false then
      if self.HFlipped ~= self.PinnedFlipped then
        self.PresetName = self.OriginalName
      end
    end
    if self.PresetName == self.OriginalName .. " (Braced)" then
      local pinnedNegatore = 1
      if user.HFlipped ~= self.PinnedFlipped then
        self:Deactivate()
        user:GetController():SetState(Controller.AIM_SHARP, false)
        pinnedNegatore = -1
      end
      self.HFlipped = self.PinnedFlipped
      if SceneMan:ShortestDistance(self.Pos + self:RotateOffset(self.BipodOffset), self.PinnedPos, SceneMan.SceneWrapsX).Magnitude > self.Diameter*2 then
        self.PresetName = self.OriginalName
      else
        if self.RotAngle > math.pi*0.25 and self.RotAngle < math.pi then
          self.RotAngle = math.pi*0.25
        else
          if self.RotAngle > math.pi*0.25 and self.RotAngle < math.pi*1.75 then
            self.RotAngle = math.pi*1.75
          end
        end
        self.RotAngle = self.RotAngle * pinnedNegatore + self.RecoilRot * negatore * 0.1
        self.Pos = self.PinnedPos - self:RotateOffset(self.BipodOffset)
        self.Vel = Vector(0, 0)
        user.Pos = self.Pos - self:RotateOffset(self.BipodStanceOffset)
        user.Vel = Vector(0, 0)
        altitude = user:GetAltitude(user.Height,0)
        if altitude >= user.Height*0.5 then
          if self.PickedUp == false then
            self.PresetName = self.OriginalName
          else
            user:GetController():SetState(Controller.WEAPON_DROP,true)
          end
        end
      end
    end
    if self.Sharpness == 10 then
      if self.PresetName == self.OriginalName then
        self.PresetName = self.OriginalName .. " (Braced)"
		self.RateOfFire = 675
        local strikePoint = Vector(0,0);
        local lastPoint = Vector(0,0);
        local dist = SceneMan:CastObstacleRay(self.Pos + self:RotateOffset(self.BipodOffset), Vector(0, self.PinDepth) , strikePoint, lastPoint, user.ID, self.IgnoresWhichTeam, -1, 0);
        if dist >= 0 then
          self.PinnedPos = self.Pos + self:RotateOffset(self.BipodOffset) + Vector(0, dist)
        end
        self.PinnedFlipped = self.HFlipped
      else
        self.PresetName = self.OriginalName
		self.RateOfFire = 475
      end
      self.Sharpness = 10
    end
    self.PickedUp = true
  else
    self.PickedUp = false
    self.Recoil = 0
    self.RecoilRot = 0
    if self.PresetName == self.OriginalName .. " (Braced)" then
      self.HFlipped = self.PinnedFlipped
      self.Pos = self.PinnedPos - self:RotateOffset(self.BipodOffset)
    end
  end
  if self.Magazine ~= nil then
    if self:IsActivated() then
      if self.Magazine.RoundCount > 0 and self.ShootTimer:IsPastSimMS(60000/self.RateOfFire) and (self.Clicked or self.FullAuto) then
        self.ShootTimer:Reset()
        self.Recoil = self.Recoil + (self.ParticleMass * self.ParticleVel / RecoilReduction)^3 * self.RecoilMulti
        self.RecoilRot = self.RecoilRot + (math.random()-0.5)*self.Recoil
        if user ~= nil then
          user:AddAbsForce( self:RotateOffset(Vector(-7350, 0)), self.Pos + self:RotateOffset(Vector(12, 1)))
        end
        self.Clicked = false
      end
    else
      self.Clicked = true
    end
  else
    self.ShootTimer:Reset()
  end
	if user ~= nil then
    self.SharpLength = self.SharpRange - (self.Recoil*self.SharpRange) * 0.3 + ((math.random(-self.Recoil*(100 - user.Health)^3, self.Recoil*(100 - user.Health)^3)*0.0000005)^2*self.SharpRange)
    self.RotAngle = self.RotAngle + self.RecoilRot * negatore * 0.1 + (math.random(-self.Recoil*(100 - user.Health)^4, self.Recoil*(100 - user.Health)^4)*0.000000005)^2 / RecoilReduction^3
  end
	if self.Magazine then
		self.Magazine.Frame = math.max (1,self.Magazine.RoundCount)
	end
end